package DAEEXT "
    Copyright (c) PELAB, Dept. Computer and Information Science, Linkoping University,
    Sweden, in the following denoted PELAB/LIU.

   
    This file is part of OpenModelica, in the following denoted OSM.


    The OSM License, Version 1.1, March 4, 2005.


    1 Preface

    The aim of this license is to lay down the conditions enabling you to use, 
    modify and circulate OSM. However, PELAB/LIU remain the authors of 
    OSM and so retain property rights and the use of all ancillary rights.

    2 Definitions

    OSM is defined as all successive versions of the OSM software and their 
    documentation that have been developed by PELAB/LIU and including
    accepted contributions from other contributors according to this license.

    OSM DERIVED SOFTWARE is defined as all or part of OSM that you have 
    modified and/or translated and/or adapted.


    3 Dual License

    OSM is made available under the OSM licensing scheme, which is a dual
    licensing scheme with two options, a) and b):

    a) OSM OPEN SOURCE LICENSE:

    If you wish to write Open Source software you can use the Open Source version 
    of OSM, released under the OSM license which include GPL as its open source 
    licensing option. If you use the OSM Open Source version you must release your 
    Application using OSM including this Application's source code under the GPL as well.

    This OSM license text, and Copyright (c) PELAB/Linkoping University, must
    be present in your copy of OSM and in OSM DERIVED SOFTWARE.

    You should have received a copy of the GPL - GNU General Public License
    along with OpenModelica; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.


    b) OSM COMMERCIAL LICENSE

    If you are using OSM commercially - that is, for commercial usage or
    for creating proprietary software for sale or use in a commercial setting
    - you must purchase a commercial license of OSM from PELAB/L
  
  file:	 DAEEXT.rml
  module:      DAEEXT
 
   
  The DAEEXT module is an externally implemented module (in file runtime/daeext.cpp) 
  used for the BLT and index reduction algorithms in 'DAELow'. The implementation 
  mainly consists of several bitvectors implemented using std::vector<bool> since 
  such functionality is not available in RML.
 "

public function init_marks
  input Integer in_integer1;
  input Integer in_integer2;

  external "C" ;
end init_marks;

public function e_mark
  input Integer in_integer;

  external "C" ;
end e_mark;

public function get_e_mark
  input Integer in_integer;
  output Boolean out_boolean;

  external "C" ;
end get_e_mark;

public function v_mark
  input Integer in_integer;

  external "C" ;
end v_mark;

public function get_v_mark
  input Integer in_integer;
  output Boolean out_boolean;

  external "C" ;
end get_v_mark;

public function get_marked_eqns
  output IntegerList out_integerlist;
protected 
  type IntegerList = list<Integer>;

  external "C" ;
end get_marked_eqns;

public function get_marked_variables
  output IntegerList out_integerlist;
protected 
  type IntegerList = list<Integer>;

  external "C" ;
end get_marked_variables;

public function dump_marked_equations
  input Integer in_integer;

  external "C" ;
end dump_marked_equations;

public function dump_marked_variables
  input Integer in_integer;

  external "C" ;
end dump_marked_variables;

public function init_lowlink
  input Integer in_integer;

  external "C" ;
end init_lowlink;

public function init_number
  input Integer in_integer;

  external "C" ;
end init_number;

public function set_lowlink
  input Integer in_integer1;
  input Integer in_integer2;

  external "C" ;
end set_lowlink;

public function get_lowlink
  input Integer in_integer;
  output Integer out_integer;

  external "C" ;
end get_lowlink;

public function set_number
  input Integer in_integer1;
  input Integer in_integer2;

  external "C" ;
end set_number;

public function get_number
  input Integer in_integer;
  output Integer out_integer;

  external "C" ;
end get_number;

public function init_v
  input Integer in_integer;

  external "C" ;
end init_v;

public function init_f
  input Integer in_integer;

  external "C" ;
end init_f;

public function set_v
  input Integer in_integer1;
  input Integer in_integer2;

  external "C" ;
end set_v;

public function get_v
  input Integer in_integer;
  output Integer out_integer;

  external "C" ;
end get_v;

public function set_f
  input Integer in_integer1;
  input Integer in_integer2;

  external "C" ;
end set_f;

public function get_f
  input Integer in_integer;
  output Integer out_integer;

  external "C" ;
end get_f;

public function vector_setnth
  input IntegerVector in_integervector1;
  input Integer in_integer2;
  input Integer in_integer3;
protected 
  type IntegerVector = Integer[:];

  external "C" ;
end vector_setnth;
end DAEEXT;

