package System "
    Copyright (c) PELAB, Dept. Computer and Information Science, Linkoping University,
    Sweden, in the following denoted PELAB/LIU.

   
    This file is part of OpenModelica, in the following denoted OSM.


    The OSM License, Version 1.1, March 4, 2005.


    1 Preface

    The aim of this license is to lay down the conditions enabling you to use, 
    modify and circulate OSM. However, PELAB/LIU remain the authors of 
    OSM and so retain property rights and the use of all ancillary rights.

    2 Definitions

    OSM is defined as all successive versions of the OSM software and their 
    documentation that have been developed by PELAB/LIU and including
    accepted contributions from other contributors according to this license.

    OSM DERIVED SOFTWARE is defined as all or part of OSM that you have 
    modified and/or translated and/or adapted.


    3 Dual License

    OSM is made available under the OSM licensing scheme, which is a dual
    licensing scheme with two options, a) and b):

    a) OSM OPEN SOURCE LICENSE:

    If you wish to write Open Source software you can use the Open Source version 
    of OSM, released under the OSM license which include GPL as its open source 
    licensing option. If you use the OSM Open Source version you must release your 
    Application using OSM including this Application's source code under the GPL as well.

    This OSM license text, and Copyright (c) PELAB/Linkoping University, must
    be present in your copy of OSM and in OSM DERIVED SOFTWARE.

    You should have received a copy of the GPL - GNU General Public License
    along with OpenModelica; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.


    b) OSM COMMERCIAL LICENSE

    If you are using OSM commercially - that is, for commercial usage or
    for creating proprietary software for sale or use in a commercial setting
    - you must purchase a commercial license of OSM from PELAB/L
  
  file:	 System.rml
  module:      System
  description: This file contains runtime system specific function, which are implemented in 
  C.
 
  RCS: $Id: System.rml 1817 2005-06-20 12:21:26Z x02lucpo $
 
  This module contain a set of system calls, for e.g. compiling and 
  executing stuff, reading and writing files and so on.
  
  
  
 "

public import OpenModelica.Compiler.Values;

public function remove_first_and_last_char
  input String in_string;
  output String out_string;

  external "C" ;
end remove_first_and_last_char;

public function strcmp
  input String in_string1;
  input String in_string2;
  output Integer out_integer;

  external "C" ;
end strcmp;

public function toupper
  input String in_string;
  output String out_string;

  external "C" ;
end toupper;

public function strtok
  input String in_string1;
  input String in_string2;
  output StringList out_stringlist;
protected 
  type StringList = list<String>;

  external "C" ;
end strtok;

public function compile_c_file
  input String in_string;

  external "C" ;
end compile_c_file;

public function compile_flat_class
  input String in_string;
  output String out_string;

  external "C" ;
end compile_flat_class;

public function set_c_compiler
  input String in_string;

  external "C" ;
end set_c_compiler;

public function set_c_flags
  input String in_string;

  external "C" ;
end set_c_flags;

public function execute_function
  input String in_string;

  external "C" ;
end execute_function;

public function write_file
  input String in_string1;
  input String in_string2;

  external "C" ;
end write_file;

public function read_file
  input String in_string;
  output String out_string;

  external "C" ;
end read_file;

public function read_values_from_file
  input String in_string;
  output Values.Value out_value;

  external "C" ;
end read_values_from_file;

public function read_ptolemyplot_dataset
  input String in_string;
  input StringList in_stringlist;
  input Integer in_integer;
  output Values.Value out_value;
protected 
  type StringList = list<String>;

  external "C" ;
end read_ptolemyplot_dataset;

public function system_call
  input String in_string;
  output Integer out_integer;

  external "C" ;
end system_call;

public function cd
  input String in_string;
  output Integer out_integer;

  external "C" ;
end cd;

public function pwd
  output String out_string;

  external "C" ;
end pwd;

public function modelicapath
  output String out_string;

  external "C" ;
end modelicapath;

public function read_env
  input String in_string;
  output String out_string;

  external "C" ;
end read_env;

public function sub_directories
  input String in_string;
  output StringList out_stringlist;
protected 
  type StringList = list<String>;

  external "C" ;
end sub_directories;

public function mo_files
  input String in_string;
  output StringList out_stringlist;
protected 
  type StringList = list<String>;

  external "C" ;
end mo_files;

public function time
  output Real out_real;

  external "C" ;
end time;

public function hash
  input String in_string;
  output Integer out_integer;

  external "C" ;
end hash;

public function path_delimiter
  output String out_string;

  external "C" ;
end path_delimiter;

public function group_delimiter
  output String out_string;

  external "C" ;
end group_delimiter;

public function regular_file_exist
  input String in_string;
  output Integer out_integer;

  external "C" ;
end regular_file_exist;

public function directory_exist
  input String in_string;
  output Integer out_integer;

  external "C" ;
end directory_exist;

public function getDebugString
  input String in_string;
  output String out_string;

  external "C" ;
end getDebugString;

public function startDebug

  external "C" ;
end startDebug;

public function endDebug

  external "C" ;
end endDebug;

public function incDebugLevel

  external "C" ;
end incDebugLevel;

public function decDebugLevel

  external "C" ;
end decDebugLevel;

public function platform
  output String out_string;

  external "C" ;
end platform;
end System;

