package TaskGraphExt "
    Copyright (c) PELAB, Dept. Computer and Information Science, Linkoping University,
    Sweden, in the following denoted PELAB/LIU.

   
    This file is part of OpenModelica, in the following denoted OSM.


    The OSM License, Version 1.1, March 4, 2005.


    1 Preface

    The aim of this license is to lay down the conditions enabling you to use, 
    modify and circulate OSM. However, PELAB/LIU remain the authors of 
    OSM and so retain property rights and the use of all ancillary rights.

    2 Definitions

    OSM is defined as all successive versions of the OSM software and their 
    documentation that have been developed by PELAB/LIU and including
    accepted contributions from other contributors according to this license.

    OSM DERIVED SOFTWARE is defined as all or part of OSM that you have 
    modified and/or translated and/or adapted.


    3 Dual License

    OSM is made available under the OSM licensing scheme, which is a dual
    licensing scheme with two options, a) and b):

    a) OSM OPEN SOURCE LICENSE:

    If you wish to write Open Source software you can use the Open Source version 
    of OSM, released under the OSM license which include GPL as its open source 
    licensing option. If you use the OSM Open Source version you must release your 
    Application using OSM including this Application's source code under the GPL as well.

    This OSM license text, and Copyright (c) PELAB/Linkoping University, must
    be present in your copy of OSM and in OSM DERIVED SOFTWARE.

    You should have received a copy of the GPL - GNU General Public License
    along with OpenModelica; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.


    b) OSM COMMERCIAL LICENSE

    If you are using OSM commercially - that is, for commercial usage or
    for creating proprietary software for sale or use in a commercial setting
    - you must purchase a commercial license of OSM from PELAB/L
  
  file:	 TaskGraphExt.rml
  module:      TaskGraphExt
  description: The external representation of a task graph, using Boost Graph Library
  in C++.
 
  RCS: $Id: TaskGraphExt.rml 1733 2005-04-27 06:47:45Z haklu $
  
 
  
  This module is the interface to the externally implemented task graph using Boost 
  Graph Library in C++
 "

public import OpenModelica.Compiler.Exp;

public import OpenModelica.Compiler.DAELow;

public function new_task
  input String in_string;
  output Integer out_integer;

  external "C" ;
end new_task;

public function add_edge
  input Integer in_integer1;
  input Integer in_integer2;
  input String in_string3;
  input Integer in_integer4;

  external "C" ;
end add_edge;

public function get_task
  input String in_string;
  output Integer out_integer;

  external "C" ;
end get_task;

public function store_result
  input String in_string1;
  input Integer in_integer2;
  input Boolean in_boolean3;
  input String in_string4;

  external "C" ;
end store_result;

public function dump_graph
  input String in_string;

  external "C" ;
end dump_graph;

public function dump_merged_graph
  input String in_string;

  external "C" ;
end dump_merged_graph;

public function register_startstop
  input Integer in_integer1;
  input Integer in_integer2;

  external "C" ;
end register_startstop;

public function get_starttask
  output Integer out_integer;

  external "C" ;
end get_starttask;

public function get_stoptask
  output Integer out_integer;

  external "C" ;
end get_stoptask;

public function merge_tasks
  input Real in_real1;
  input Real in_real2;

  external "C" ;
end merge_tasks;

public function schedule
  input Integer in_integer;

  external "C" ;
end schedule;

public function generate_code
  input Integer in_integer1;
  input Integer in_integer2;
  input Integer in_integer3;

  external "C" ;
end generate_code;

public function set_execcost
  input Integer in_integer;
  input Real in_real;

  external "C" ;
end set_execcost;

public function set_tasktype
  input Integer in_integer1;
  input Integer in_integer2;

  external "C" ;
end set_tasktype;

public function set_commcost
  input Integer in_integer1;
  input Integer in_integer2;
  input Integer in_integer3;

  external "C" ;
end set_commcost;

public function add_initvar
  input Integer in_integer1;
  input String in_string2;
  input String in_string3;

  external "C" ;
end add_initvar;

public function add_initstate
  input Integer in_integer1;
  input String in_string2;
  input String in_string3;

  external "C" ;
end add_initstate;

public function add_initparam
  input Integer in_integer1;
  input String in_string2;
  input String in_string3;

  external "C" ;
end add_initparam;
end TaskGraphExt;

